'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'asynchronousNotification.vbs - connect to WMI and
'register for asynchronous event notification
'block until user clicks "OK" and then cancel notification
Option Explicit
Dim refWMI
Dim refSink
Dim strQuery

'connect to WMI and create a sink object
Set refWMI = GetObject("winMgmts:{(security)}")
Set refSink = CreateObject("WBemScripting.SWbemSink")
WScript.ConnectObject refSink ,"EVENTSINK_"

'execute an async notification query
strQuery = "SELECT * FROM __InstanceCreationEvent " & _
	"WHERE TargetInstance ISA 'Win32_NTLogEvent'"

refWMI.ExecNotificationQueryAsync refSink, strQuery

'block until user clicks ok - at this stage we are able
'to receive asynchronous event notifications because
'WScript can call EVENTSINK_OnObjectReady() whenever it wants
MsgBox "Click here to stop receiving event notifications"

'when we reach here, "OK" must have been clicked
'so cancel event notification
refSink.Cancel()

'now we can disconnect the sink from WScript and lose
'a reference to it. This step is not necessary, as it
'will happen anyway when the script quits, but it's
'aesthetically pleasing :)
WScript.DisconnectObject(refSink)
Set refSink = Nothing
set refWMI = Nothing

'--end of script

'callback for Event Notification
Sub EVENTSINK_OnObjectReady(refEvent,refContext)
	WScript.Echo refEvent.Path_.Class
End Sub
