'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'checkprovider.vbs - check whether an Event Provider
'exists for a cmd-line specified target
Option Explicit
On Error Resume Next
Dim strQuery
Dim refWMI
Dim refEventSource

'first check cmd-line args for sanity
If WScript.Arguments.Count <> 1 Then
	WScript.Echo "Usage: checkprovider.vbs <classname>"
	WScript.Quit
End If

'now build query that registers for all creations of
'the specified TargetInstance
strQuery = "SELECT * FROM __InstanceCreationEvent WHERE " & _
	"TargetInstance ISA '" & WScript.Arguments(0) & "'"

'now connect to WMI and test the query
'enable Security privelege for Event Log and the like
set refWMI = GetObject("winMgmts:{(security)}")
set refEventSource = refWMI.ExecNotificationQuery(strQuery)

'check the error and report accordingly
'-2147213310 corresponds to 0x40082002, the error code for
'the missing event provider error
Select Case Err.Number
	Case -2147213310: WScript.Echo "WITHIN clause required."
	Case 0: WScript.Echo "Event provider exists."
	Case Else: WScript.Echo "Oops. An error occurred. "
End Select

Set refWMI = Nothing
Set refEventSource = Nothing
