'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'coollogreport.vbs - create an HTML report of all Error events
'logged in the event logs on a set of computers
Option Explicit
On Error Resume Next
Dim strReportFile
Dim refReport
Dim colEvents
Dim refEntry
Dim refWMI
Dim strQuery
Dim i

'check cmd-line args
If WScript.Arguments.Count < 2 Then
	WScript.Echo "Usage: coollogreport.vbs <reportfile> " _
		& "<machine1> [machine2 machine3 etc.]"
	WScript.Quit
End If

strReportFile = WScript.Arguments(0)

'create and initialise a SimpleReport object
Set refReport = CreateObject("WMIBook.SimpleReport")
refReport.Title = "Report of 'Error' entries in the NT Event Logs"
refReport.Comment = "This report contains a list of 'Error' " & _
	"entries that appear in the NT Event Logs on a set of " & _
	"important machines on the network, as at " & Now()

strQuery = "SELECT * FROM Win32_NTLogEvent WHERE Type='Error'"

'loop through each machine in turn
For i = 1 to WScript.Arguments.Count -1
	'add a report section for the machine
	refReport.addSection "Machine: " & WScript.Arguments(i)
	'try to connect to WMI
	Set refWMI = GetObject("winMgmts:{(security)}!\\" & _
		WScript.arguments(i) & ":")
	If Err <> 0 Then
		refReport.addEntry "Connection Failure", _
			"Unable to connect to WMI",""
	Else
		Set colEvents = refWMI.ExecQuery(strQuery)
		For Each refEntry In colEvents
			'add an index consisting of the first 75 chars of message
			'a title of Logfile - Source and then the full entry
			refReport.addEntry Left(refEntry.Message,75), _
			refEntry.Logfile & " - " & refEntry.SourceName & _
				"[" & GetVBDate(refEntry.TimeWritten) & "]", _
			refEntry.Message
		Next
	End If
Next

'save and display results
refReport.browse strReportFile

Set colEvents = Nothing
Set refWMI = Nothing
Set refReport = Nothing

'--- end of script

'turn a WMI date into a VBDate
Function GetVBDate(wd)
GetVBDate = DateSerial(Left(wd,4),Mid(wd,5,2),Mid(wd,7,2)) _
	+ TimeSerial(Mid(wd,9,2),Mid(wd,11,2),Mid(wd,13,2))
End Function
