'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'diskspace.vbs - email administrator when hard disks
'on monitored machines become too full
Option Explicit
On Error Resume Next
Dim refWMI
Dim refDiskSink
Dim refProcSink
Dim numLimit
Dim strQuery
Dim boolKeepLooping
Dim refOutlook
Dim i

'change this to point to the right email address
Const ADMINISTRATOR = "w2kadmin@someorganization.com"

'check command line for sanity and save first one into numLimit
If WScript.Arguments.Count < 2 Then
	WScript.Echo "Usage: diskspace.vbs <free> <machine> [machines...]"
	WScript.Quit
End If

numLimit = WScript.Arguments(0)
If Not IsNumeric(numLimit) Then
	WScript.Echo "free space must be specified as a number of bytes."
	WScript.Quit
End If

'create a Microsoft Outlook scripting object
Set refOutlook = CreateObject("Outlook.Application")
If Err <> 0 Then
	WScript.Echo "Unable to create Outlook object. Oh dear."
	WScript.Quit
End If

'create two sinks (one for disk space notification and
'one to detect Win32_Processes) and connect them to WScript
Set refDiskSink = _
	WScript.CreateObject("WBemScripting.SWbemSink", "DISKSINK_")
Set refProcSink = _
	WScript.CreateObject("WBemScripting.SWbemSink", "PROCSINK_")
If Err <> 0 Then
	WScript.Echo "Unable to create SWbemSink objects. Oh dear."
	WScript.Quit
End If

'connect to WMI on local machine and attempt to register
'Win32_Process Query for 1 minute poll or quit
strQuery = "SELECT * FROM __InstanceCreationEvent " & _
	"WITHIN 60 WHERE TargetInstance ISA 'Win32_Process' " & _
	"AND TargetInstance.Name = 'stopscript.exe'"
Set refWMI = GetObject("winMgmts:")
refWMI.ExecNotificationQueryAsync refProcSink, strQuery
If Err <> 0 Then
	WScript.Echo "Could not register with local WMI. Sorry."
	WScript.Quit
End If

'construct WQL event query for disk monitoring every 2 mins
strQuery = "SELECT * FROM __InstanceModificationEvent " & _
	"WITHIN 120 WHERE TargetInstance ISA " & _
	"'Win32_LogicalDisk' AND TargetInstance.FreeSpace < " & _
	numLimit

'loop through each cmd-line specified machine and
'attempt to connect to WMI on each one and register
'the query. Report failure to WScript.Echo()
For i = 1 To WScript.Arguments.Count - 1
	Set refWMI = GetObject("winMgmts:\\" & WScript.Arguments(i))
	If Err <> 0 Then
		WScript.Echo "Could not connect to " & WScript.Arguments(i)
	Else
		refWMI.ExecNotificationQueryAsync refDiskSink, strQuery
		If Err <> 0 Then WScript.Echo _
			"Could not register query on " & WScript.Arguments(i)
	End If
Next
Set refWMI = Nothing

'start loop that continues until boolKeepLooping is toggled
boolKeepLooping = true
While boolKeepLooping
	WScript.Sleep 5
Wend

'when we reach here, a stopscript.exe Win32_Process must
'have been started so cancel event notification
refDiskSink.Cancel()
refProcSink.Cancel()

'tidy up
WScript.DisconnectObject(refDiskSink)
WScript.DisconnectObject(refProcSink)
Set refDiskSink = Nothing
Set refProcSink = Nothing

'--end of script

'callback for Disk Monitoring
Sub DISKSINK_OnObjectReady(refEvent,refContext)
	Dim refMailItem
	WScript.Echo "PING"
	Set refMailItem = refOutlook.CreateItem(0)
	refMailItem.To = ADMINISTRATOR
	refMailItem.Subject = "DISK FULL!!"
	refMailItem.Body = "The disk is full on " & _
	refEvent.Path_.Server & chr(13) & chr(13) & _
		"Only " & refEvent.TargetInstance.FreeSpace & _
		" bytes remain."
	refMailItem.Send
End Sub

'callback for Process monitoring
Sub PROCSINK_OnObjectReady(refEvent,refContext)
	boolKeepLooping = false
End Sub
