'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'featurereport.vbs - create a report listing all products and
'features installed on a set of workstations whose names or
'IPs are specified in a file
Option Explicit
On Error Resume Next
Dim strReportFile
Dim strMachineFile
Dim strMachineName
Dim refFSO
Dim refMachineFile
Dim refReport
Dim refWMI
Dim colInstProducts
Dim refProduct
Dim colFeatures
Dim refFeature
Dim strFullDescription

'check cmd-line args for sanity and attempt to
'open input file
If WScript.Arguments.Count <> 2 Then
	WScript.Echo "Usage: featurereport.vbs <reportfilename> " & _
		" <machinefilename>"
	WScript.Quit
End If

strReportFile = WScript.Arguments(0)
strMachineFile = WScript.Arguments(1)

'attempt to open machine file
Set refFSO = CreateObject("Scripting.FilesystemObject")
Set refMachineFile = refFSO.OpenTextFile(strMachineFile)
If Err <> 0 Then
	WScript.Echo "Sorry. Could not open machine file"
	WScript.Quit
End If

'Initialize report
Set refReport = CreateObject("WMIBook.SimpleReport")
refReport.title = "Software on my computer"
refReport.comment = "This report lists all the software " & _
	"products installed on my computer under the control " & _
	"of the Windows Installer"

'loop through each machine
While Not refMachineFile.AtEndOfStream
	'connect to WMI and retrieve collection of Win32_Products
	strMachineName = refMachineFile.readLine()
	Set refWMI = GetObject("winmgmts:\\" & strMachineName & ":")
	If Err <> 0 Then
		WScript.Echo "Could not connect to WMI on " & _
			strMachineName
	Else
		'add new report section and report progress with WScript.Echo
		refReport.addSection(strMachineName)
		WScript.Echo "Getting data from " & strMachineName
		
		'Loop through Products
		Set colInstProducts = refWMI.InstancesOf("Win32_Product")
		For Each refProduct in colInstProducts
			'build product part of full_description for report
			strFullDescription = _
				"Product version: " & refProduct.Version & _
				"<br> IndentifyingNumber: " & _
				refProduct.IdentifyingNumber & _
				"<br>Description: " & refProduct.Description & _
				"<br>" & "Installed features: <br>"

			'now loop through features, appending Description
			'and version of all which are installed locally
			Set colFeatures = refProduct.Associators_( _
				"Win32_ProductSoftwareFeatures")
			For Each refFeature In colFeatures
				If refFeature.InstallState = 3 Then
					strFullDescription = strFullDescription & _
						refFeature.Description & " (" & _
						refFeature.Version & _
						"), "
				End If
			Next

			'now add the report entry for this product on this machine
			refReport.addEntry refProduct.Name, _
			refProduct.Name, strFullDescription
		Next
	End If
Wend

'finally, write and display report
refReport.Browse(strReportFile)

Set colFeatures = Nothing
Set ColInstProducts = Nothing
Set refWMI = Nothing
Set refReport = Nothing
Set refMachineFile = Nothing
Set refFSO = Nothing
