'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'killit.vbs - terminate a named process on a set of computers
Option Explicit
On Error Resume Next
Dim refWMI
Dim colProcesses
Dim refProcess
Dim strMoniker
Dim strQuery
Dim i

'check to see that we have supplied at least two arguments
'if not, then print a usage message and quit
If WScript.Arguments.Count < 2 Then
	Representation of Processes in WMI 19
	WScript.Echo "Usage: killit.vbs <process name> [<machine name>]"
	WScript.Quit
End If

'build the query string using the first command line argument
'this query will be used on all machines
strQuery = "select * from Win32_Process where Name='" _
		& WScript.Arguments(0) & "'"

'loop through each of the remaining command-line arguments
'these are assumed to be machine names (or, of course, IP addresses)
For i = 1 to WScript.Arguments.Count - 1

	'reset the Err object to ensure that any non-zero Err.Number comes
	'from this part of the code
	Err.Clear()
	
	'build a moniker string for the machine and try to get
	'an object reference
	strMoniker = "winmgmts:\\" & WScript.Arguments(i)
	set refWMI = GetObject(strMoniker)

	'did we successfully connect to the machine?
	If Err.Number <> 0 Then
		WScript.Echo "Failed to connect to " & WScript.Arguments(i)
	Else
		'good - we did. Get a collection of all relevant process objects
		Set colProcesses = refWMI.ExecQuery(strQuery)
		If colProcesses.Count=0 Then
			'none was found - we perform this check even though it is
			'not strictly necessary (For Each ... Next would not error out
			'on Count=0) because it allows us to print this friendly message
			WScript.Echo WScript.Arguments(0) & " - Not found on "_
						& WScript.Arguments(i)
		Else
			'we have some process objects, so loop through and terminate them
			For Each refProcess in colProcesses
				If refProcess.Terminate()=0 Then
					WScript.Echo "(PID " & refProcess.Handle & ") "_
					& refProcess.Name & " Terminated on - "_
					& WScript.Arguments(i)
				Else
					WScript.Echo "Unable to terminate - "_
					& refProcess.Name & " on "_
					& WScript.Arguments(i)
				End If
			Next
		End If
	End If
	Set colProcesses = Nothing
	Set refWMI = Nothing
Next
