'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'loginfo.vbs - display information about the overwrite policy and
'registered sources for each Event Log on a computer
Option Explicit
On Error Resume Next
Dim strMoniker
Dim refWMI
Dim colEventLogs
Dim refEventLog
Dim strSource

'moniker string stub - security privilege needed to get
'numrecords for Security log
strMoniker = "winMgmts:{(Security)}!"

'append to moniker string if a machine name has been given
If WScript.Arguments.Count = 1 Then _
	strMoniker = strMoniker & "\\" & WScript.Arguments(0) & ":"
	
'attempt to connect to WMI
Set refWMI = GetObject(strMoniker)
If Err <> 0 Then
	WScript.Echo "Could not connect to the WMI service."
	WScript.Quit
End If

'get a collection of Win32_NTEventLogFile objects
Set colEventLogs = refWMI.InstancesOf("Win32_NTEventLogFile")
If Err <> 0 Then
	WScript.Echo "Could not retrieve Event Log objects"
	WScript.Quit
End If

'iterate through each log and output information
For Each refEventLog In colEventLogs
	WScript.Echo "Information for the " & _
		refEventLog.LogfileName & _
		" log:"
	WScript.Echo " Current file size: " & refEventLog.FileSize
	WScript.Echo " Maximum file size: " & refEventLog.MaxFileSize
	WScript.Echo " The Log currently contains " & _
	refEventLog.NumberOfRecords & " records"

	'output policy info in a friendly format using OverwriteOutDated,
	'as OverWritePolicy is utterly pointless.
	'note "-1" is the signed interpretation of 4294967295
	Select Case refEventLog.OverwriteOutDated
		Case 0 WScript.Echo _
			" Log entries may be overwritten as required"
		Case -1 WScript.Echo _
			" Log entries may NEVER be overwritten"
		Case Else WScript.Echo _
			" Log entries may be overwritten after " & _
		refEventLog.OverwriteOutDated & " days"
	End Select

	'now print out list of registered sources - note extra spaces
	'are for cosmetic reasons
	WScript.Echo " The following are registered Sources for this log:"
	For Each strSource In refEventLog.Sources
		WScript.Echo " " & strSource
	Next
Next

Set refEventLog = Nothing
Set colEventLogs = Nothing
Set refWMI = Nothing