'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

# service-events.pl - go ping within 10 seconds of
# a service starting or stopping
#declare use of OLE module and init console
use Win32::OLE qw(EVENTS);
use Win32::Console;
my $console = Win32::Console->new(STD_INPUT_HANDLE);

#connect to WMI and create a sink object
my $refWMI = Win32::OLE->GetObject("winMgmts:");
my $refSink = Win32::OLE->new ('WBemScripting.SWbemSink');

#register $refSink as an event provider
Win32::OLE->WithEvents($refSink,\&eventCallback);

#execute an async notification query and block with a msgbox
my $strQuery = "SELECT * FROM __instancemodificationevent "
	. "WITHIN 10 WHERE TargetInstance ISA 'Win32_Service'";
$refWMI->ExecNotificationQueryAsync($refSink, $strQuery);

#spin message loop
print "Waiting for events...\n";
my $continueLooping = 1;
while ($continueLooping){
	#if a key has been pressed, quit
	if ($console->GetEvents() != 0){
		my @cons = $console->Input();
		if ($cons[1] != 0){
			undef $continueLooping;
		}
	}
	Win32::OLE->SpinMessageLoop();
	Win32::Sleep(500);
}

#cancel event notification
$refSink->Cancel();
Win32::OLE->WithEvents($refSink);
undef $refSink;
undef $refWMI;
undef $console;
print "Finished.\n";

# callback forEvent Notification
#note we are not discriminating between the various
#IWbemObjectSink methods here
sub eventCallback()
{
	my ($refSource,$refEventName,$refEvent,$refContext) = @_;
	if ($refEventName eq "OnObjectReady") {
		print $refEvent->TargetInstance->{Name}
			. " has "
			. ($refEvent->TargetInstance->{Started}
			? "started" : "stopped")
			. "\n";
	}
}
