'This script accompanies the book Windows Management Instrumentation
'by Matthew Lavy and Ashley Meggitt (New Riders, 2001)
'The code is copyright 2001, Matthew Lavy & Ashley Meggitt
'You are free to use and modify the script at will
'provided you understand that all code here is made available AS IS, with
'NO WARRANTY WHATSOEVER. The authors take NO RESPONSIBILITY AT ALL for
'problems that result from the use of this script or any part thereof

'servicecontrol.vbs  find out about or control services
Option Explicit
On Error Resume Next
Dim refWMI
Dim refService
Dim strService
Dim strRequestedState
Dim strMachineName
Dim numResult
Dim strInfo

'check cmd-line arguments for sanity
If WScript.Arguments.Count < 2 Then
	WScript.Echo "Usage: ServiceControl.vbs <machine> <service> " & _
		"[<requested state>]"
	WScript.Quit
End If

'turn WScript.Arguments into something more readable
strMachineName = WScript.Arguments(0)
strService = WScript.Arguments(1)
If WScript.Arguments.Count > 2 Then
	strRequestedState = LCase(WScript.Arguments(2))
End If

'connect to the WMI service
Set refWMI = GetObject("winMgmts:\\" & strMachineName)
If Err <> 0 Then
	WScript.Echo "Could not connect to the WMI service"
	WScript.Quit
End If

'attempt to retrieve a reference to the service
Set refService = refWMI.Get("Win32_Service.Name='" & strService & "'")
If Err <> 0 Then
	WScript.Echo "Could not find the " & strService & " service."
	WScript.Quit
End If

If IsEmpty(strRequestedState) Then
	'no change parameters were specified, so output current status
	WScript.Echo refService.Description
	WScript.Echo " The service is currently: " & refService.State
	WScript.Echo " Start Mode: " & refService.StartMode
Else
	'an action has been requested  work out what an act accordingly
	Select Case strRequestedState
		Case "start" : WScript.Echo SrvErrorCheck( _
			refService.StartService,strRequestedState)
		Case "stop" : WScript.Echo SrvErrorCheck( _
			refService.StopService,strRequestedState)
		Case "pause" : WScript.Echo SrvErrorCheck( _
			refService.PauseService,strRequestedState)
		Case "resume": WScript.Echo SrvErrorCheck( _
			refService.ResumeService,strRequestedState)
		Case Else:
			'assume its an attempt at setting startup state
			WScript.Echo SrvErrorCheck( _
				refService.ChangeStartMode( _
					strRequestedState), strRequestedState)
	End Select
End If
Set refService = Nothing
Set refWMI = Nothing

'srvErrorCheck function interprets common error codes returned
'by Win32_Service methods
Function SrvErrorCheck(numResult,strInfo)
	Select Case numResult
		Case 0 : srvErrorCheck = "Service State Changed to " & strInfo
		Case 1 : srvErrorCheck = "Request not supported"
		Case 3 : srvErrorCheck = "Not stopped - dependencies found"
		Case 10 : srvErrorCheck = "Service already running"
		Case 14 : srvErrorCheck = "Service is disabled"
		Case Else : srvErrorCheck = "Unkown Error - " & _
			"Service state not changed to "& strInfo
	End Select
End Function
